/**
 * Javascript for adding time entries with the timetracker form.
 */
(function ($) {
  Drupal.behaviors.timetracker_charts = {
    attach: function (context) {
      if (context === document) {

        // Get the chart element and the raw data.
        var ctx = document.getElementById('time-entries').getContext('2d');
        var raw_data = drupalSettings.openlucius_timetracker.data;

        var labels = [];
        var time_data = [];

        // Place the date and time in the chartData below.
        if (raw_data) {
          $.each(raw_data, function (index, value) {
            labels.push(index);
            time_data.push(value);
          });
        }

        // Add the chart data.
        var chartData = {
          labels: labels,
          datasets: [
            {
              label: 'Clocked time',
              fillColor: 'rgba(220,220,220,0.5)',
              strokeColor: 'rgba(220,220,220,0.8)',
              highlightFill: 'rgba(220,220,220,0.75)',
              highlightStroke: 'rgba(220,220,220,1)',
              data: time_data
            }
          ]
        };

        // Set the options.
        var chartOptions = {
          scales: {
            yAxes: [
              {
                ticks: {
                  beginAtZero: true
                }
              }
            ]
          }
        };

        // Create the chart.
        var barChart = new Chart(ctx, {
          type: 'bar',
          data: chartData,
          options: chartOptions
        });
      }
    }
  };
}(jQuery, Drupal, drupalSettings));
