<?php

namespace Drupal\openlucius_timetracker;

/**
 * Interface TimeServiceInterface.
 *
 * @package Drupal\openlucius_timetracker
 */
interface TimetrackerInterface {

  /**
   * Creates a time entry.
   *
   * @param int $nid
   *   The current node id.
   * @param int $uid
   *   The current user id.
   * @param int $start
   *   The start timestamp.
   * @param int $stop
   *   The stop timestamp.
   * @param string $message
   *   The message.
   */
  public function createTimeEntry($nid, $uid, $start, $stop, $message);

  /**
   * Reads a time entry.
   *
   * @param int $nid
   *   The current node id.
   * @param int $uid
   *   The user id.
   */
  public function readTimeEntry($nid, $uid);

  /**
   * Updates a time entry.
   *
   * @param int $nid
   *   The current node id.
   * @param int $uid
   *   The current user id.
   */
  public function updateTimeEntry($nid, $uid);

  /**
   * Deletes a time entry.
   *
   * @param int $nid
   *   The current node id.
   * @param int $uid
   *   The current user id.
   */
  public function deleteTimeEntry($nid, $uid);
}
