<?php

namespace Drupal\openlucius_channel\Controller;

use Drupal\Component\Utility\Tags;
use Drupal\Component\Utility\Unicode;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class AutocompleteController.
 *
 * @package Drupal\openlucius_channel\Controller
 */
class AutocompleteController extends ControllerBase {

  /**
   * Method to handle autocomplete of create channel modal.
   */
  public function handleAutocomplete(Request $request) {
    $results = [];

    // Get the typed string from the URL, if it exists.
    if ($input = $request->query->get('q')) {
      $typed_string = Tags::explode($input);
      $typed_string = Unicode::strtolower(array_pop($typed_string));

      $query = \Drupal::database()->select('ol_user_team', 'ost');
      $query->addField('ufd', 'name', 'label');
      $query->addField('ost', 'uid', 'id');
      $query->join('users_field_data', 'ufd', 'ufd.uid = ost.uid');
      $query->condition('ost.team_id', getTeamId());
      $query->condition('ufd.name', $query->escapeLike($typed_string) . '%', 'LIKE');
      $results = $query->execute()->fetchAll();

    }

    return new JsonResponse($results);
  }
}