<?php

namespace Drupal\openlucius_channel\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\file\Entity\File;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * File upload.
 */
class FileUploadHandler extends ControllerBase {


  public function FileHandler() {


    // Check channel access, return false if check is false
    if(checkChannelAccess($_POST['cid'], 'FileHandler') != TRUE){ return FALSE; }

    // Set a counter for duplicate file names.
    $i = 0;
    // Get the file name.
    $file_name = $_FILES['file']['name'];

    // Get the tmp file location.
    $tempFile = $_FILES['file']['tmp_name'];

    // Get the private directory.
    $targetPath = file_default_scheme() . '://';

    // Get the location of where the file should be stored.
    $targetFile = $targetPath . $file_name;

    // Check if file already exists.
    if (!empty($file_name)) {
      while (file_exists($targetFile)) {
        if ($i > 0 && file_exists($targetFile)) {
          $targetFile = $targetPath . $file_name . $i;
          $newFileName = $file_name .$i ;
        }
        $i++;
      }

      if (!$newFileName) {
        $newFileName = $file_name;
      }

      // Save the original file to the private directory.
      move_uploaded_file($tempFile, $targetFile);

      // Create entry in the drupal db.
      $file = file_save_data($_FILES['file']['name'], $targetPath, FILE_EXISTS_RENAME);

      // Load the recently saved file.
      $newFile = File::load($file->id());
      unlink($newFile->getFileUri());
      // Set the uri.
      $newFile->setFileUrI($targetFile);

      // Set the correct mime-type.
      $newFile->setMimeType($_FILES['file']['type']);

      // Set the name.
      $newFile->setFilename($newFileName);

      // Save the db entry.
      $newFile->save();

      // Create a new entry in custom table to check access when downloading.
      $query = \Drupal::database()->insert('ol_channel_files');
      $query->fields([
        'cid',
        'fid'
      ]);
      $query->values([
        $_POST['cid'],
        $newFile->id()
      ]);
      $query->execute();

      return JsonResponse::create(['filePath' => file_create_url($newFile->getFileUri())]);
    } else {
      return JsonResponse::create(['failed' => TRUE]);
    }
  }

  // Route name /files for testing checking files.
  public function currentFiles() {
    $files = [];

    foreach (scandir(realpath('../') . DIRECTORY_SEPARATOR . 'files' . DIRECTORY_SEPARATOR) as $file) {
      if (!is_dir($file)) {
        $files[] = $file;
      }
    }

    return JsonResponse::create(['files' => $files]);
  }


}