<?php

namespace Drupal\openlucius_channel\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Database\Database;
use Drupal\Core\Url;
use Drupal\file\Entity\File;
use Drupal\openlucius_channel\Entity\Channel;
use Drupal\user\Entity\User;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Provides route responses for the Example module.
 */
class TaskController extends ControllerBase {


  /**
   * Function used by Ajax-call to edit the assigned task
   */
  public function changeAssignedTask() {

    // Load parameter. Channel id.
    $uid = $_GET['uid'];
    $cid = $_GET['cid'];
    $cid = \GuzzleHttp\json_decode($cid);

    // Check channel access, return false if check is false
    if(checkChannelAccess($cid, 'changeAssignedTask') != TRUE){ return FALSE; }

    // Update channel description
    $query = \Drupal::database()->update('ol_tasks');
    $query->fields(['assigned' => $uid]);
    $query->condition('tid', $cid);
    $query->execute();

    $my_array = array(
      'cid' => $cid,
      'uid' => $uid,
    );
    return new JsonResponse($my_array);
  }

  /**
   * Function used by Ajax-call to edit due date of a task.
   */
  public function changeDueDateTask() {

    // Load parameter. Channel id.
    $due_date = $_GET['due_date'];
    $cid = $_GET['cid'];
    $cid = \GuzzleHttp\json_decode($cid);

    // Check channel access, return false if check is false
    if(checkChannelAccess($cid, 'changeAssignedTask') != TRUE){ return FALSE; }

    // Update channel description
    $query = \Drupal::database()->update('ol_tasks');
    $query->fields(['duedate' => $due_date]);
    $query->condition('tid', $cid);
    $query->execute();

    $my_array = array(
      'cid' => $cid,
      'due_date ' => $due_date,
    );
    return new JsonResponse($my_array);
  }

}
