<?php
/**
 * @file
 * Contains \Drupal\openlucius_channel\Form\AddUserForm.
 */

namespace Drupal\openlucius_channel\Form;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Session\AccountInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Contribute form.
 */
class RemoveUserForm extends FormBase {
  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'openlucius_channel_remove_user_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state,$channelid = NULL,$uid = NULL) {
    $channel = \Drupal::entityTypeManager()->getStorage('channel')->load($channelid);
    $otherUsers = '';
//    $getUsers = $channel->getUsers();

//    if ($getUsers != '') {
//      foreach ($getUsers as $otherUser) {
//        $otherUsers .= '<li>' . $otherUser->uid . '</li>';
////      }
//    }
    $form['users'] = array(
      '#type' => 'entity_autocomplete',
      '#placeholder' => t((string)$uid),
      '#tags' => TRUE,
      '#target_type' => 'user',
      '#required' => TRUE,
      '#attributes' => array(
        'class' => array('form-control'),),
    );
    $form['submit'] = array(
      '#title' => 'Remove ... from channel?',
      '#type' => 'submit',
      '#value' => t('Submit'),
    );

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {


    global $base_path;

    // Fill array with form values.
    $formContent = $form_state->getValues();

    // Load parameter. Channel id.
    $cid = \Drupal::request()->attributes->get('channelid');

    // Load channel.
    $channel = \Drupal::entityTypeManager()->getStorage('channel')->load($cid);

    // Remove given users from channel.
    if (isset($formContent['users'])) {
      foreach ($formContent['users'] as $removeUser){
        $channel->removeUsers($removeUser['target_id']);
      }
    }

    // Redirect user back to channel.
    $response = new RedirectResponse($base_path);
    $response->send();
    return;

  }
}
?>