<?php

namespace Drupal\openlucius_core\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Class CoreController.
 *
 * @package Drupal\openlucius_core\Controller
 */
class CoreController extends ControllerBase {

  /**
   * Function that loads the homepage.
   */
  public function getHomePage() {

    global $base_path;

    // Check if the user has channels available.
    $cid = getAvailableChannels(\Drupal::currentUser()->id());

    // Check if the user has access to a channel.
    if ($cid) {
      $response = new RedirectResponse($base_path . "channel/" . $cid . "/message");
      $response->send();
      return;
    }

    // Get the config.
    $config = \Drupal::config('openlucius_config.settings');
    $message = $config->get('openlucius_intro_message');

    // No caching, else homepage will return 'no channels' messages, even when there are channels
    $cacheTime = array('max-age' => 0);

    $element = array(
      '#theme' => 'homepage_block',
      '#intro_message' => $message,
      '#cache' => $cacheTime,
    );

    return $element;
  }

}
