/**
 * @file
 * Something.
 */

/**
 * New private message box validate.
 */

function myFunction() {
  var e = event || window.event;  // get event object
  var key = e.keyCode || e.which; // get key cross-browser

  if (key == 188) { //if it is not a number ascii code
    //Prevent default action, which is inserting character
    if (e.preventDefault) e.preventDefault(); //normal browsers
    e.returnValue = false; //IE
  }
}

(function ($, Drupal, drupalSettings) {

  'use strict';

  /**
   * @type {Drupal~behavior}
   */
  Drupal.behaviors.menuUiChangeParentItems = {

    attach: function (context, settings) {

      /**
       * Change channel icon to '+' icon for adding tasks in channels
       */

      $('.channel_li').on('mouseover', function() {
        var li$ = $(this);
        li$.find('button').first().removeClass('fa fa-circle-o-notch');
        li$.find('button').first().addClass('fa fa-plus more_padding');
      })
        .on('mouseout', function() {
          var li$ = $(this);
          li$.find('button').first().removeClass('fa fa-plus more_padding');
          li$.find('button').first().addClass('fa fa-circle-o-notch');
        });

      $('.channel_li_pm').on('mouseover', function() {
        var li$ = $(this);
        li$.find('button').first().removeClass('fa fa-lock');
        li$.find('button').first().addClass('fa fa-plus more_padding');
      })
        .on('mouseout', function() {
          var li$ = $(this);
          li$.find('button').first().removeClass('fa fa-plus more_padding');
          li$.find('button').first().addClass('fa fa-lock');
        });


      /**
       * Change assigned user at a task
       */
      $("#due_date").change(function () {

        //var data = "";
        var due_date = $(this).val();
        var cid = $(".cid").val();

        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: drupalSettings.basepath + 'changeDueDateTask',
          dataType: 'json',
          success: function (data) {

            Command: toastr["success"]("Due Date set.", "Success");

            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          error: function (xhr, ajaxOptions, thrownError) {
            alert('Could not change due date.');
          },
          data: {
            _format: 'json',
            due_date: due_date,
            cid: cid
          }
        });
      });



      /**
       * Mark task as done via left sidebar
       */

        //$("#mark_task_as_done").click(function(){
      $('.sidebar-menu').on('click', '#create_task_left_sidebar', function (e) {

        // Prevent from refresh, because we are in a <a>
        e.preventDefault();
      });


      /**
       * Mark task as done via left sidebar
       */

        $('.sidebar-menu').on('click', '#mark_task_as_done', function (e) {

          // Prevent from refresh, because we are in a <a>
          e.preventDefault();

          // Get task (channel) id
          var cid = $(this).data('id');

          $.ajax({
            type: 'GET',
            contentType: "application/json",
            url: drupalSettings.basepath + 'archiveChannel',
            dataType: 'json',
            success: function (data) {

              // Hide this file from sidebar
             $("#task_id_"+cid).hide();

              // Toastr if successfull.
              Command: toastr["success"]("Task done! You can find it in the Archive now.", "Success")
              toastr.options = {
                "closeButton": false,
                "debug": false,
                "newestOnTop": false,
                "progressBar": false,
                "positionClass": "toast-top-center",
                "preventDuplicates": true,
                "onclick": null,
                "showDuration": "300",
                "hideDuration": "1000",
                "timeOut": "5000",
                "extendedTimeOut": "1000",
                "showEasing": "swing",
                "hideEasing": "linear",
                "showMethod": "fadeIn",
                "hideMethod": "fadeOut"
              }
            },
            error: function (xhr, ajaxOptions, thrownError) {
              alert('Could not assign task.');
            },
            data: {
              _format: 'json',
              cid: cid
            }
          });
        });


      /**
       * Mark task as done via title bar
       */

        //$("#mark_task_as_done").click(function(){
      $('#channel-name-bar').on('click', '#mark_task_as_done_titlebar', function (e) {

        // Prevent from refresh, because we are in a <a>
        e.preventDefault();

        // Get task (channel) id
        var cid = $(this).data('id');

        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: drupalSettings.basepath + 'archiveChannel',
          dataType: 'json',
          success: function (data) {

            // Hide this file from sidebar
            $("#task_id_"+cid).hide();
            $('#mark_as_done_check_icon').css('color' , '#00a65a');

            // Toastr if successfull.
            Command: toastr["success"]("Task done! You can find it in the Archive now.", "Success")
            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          error: function (xhr, ajaxOptions, thrownError) {
            alert('Could not assign task.');
          },
          data: {
            _format: 'json',
            cid: cid
          }
        });
      });


      /**
       * Change assigned user at a task
       */
      $("#select_assigned_user").change(function(){

        var uid = $(this).val();
        var username = $(this ).find("option:selected").text()
        var cid = $(".cid").val();

        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: drupalSettings.basepath + 'changeAssignedTask',
          dataType: 'json',
          success: function (data) {

            $("#assigned_left_sidebar_"+cid).text('['+username+']');

            Command: toastr["success"]("Task assigned.", "Success")
            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          error: function (xhr, ajaxOptions, thrownError) {
            alert('Could not assign task.');
          },
          data: {
            _format: 'json',
            uid: uid,
            cid: cid
          }
        });

      });


      /**
       * Archive Channel
       */

      $(".create_task_modal").click(function(){
        //$(document).once().on('click', '.open-archive-channel-modal', function() {
        var cid = $(this).data('id');
        $(".modal-body #cid").val( cid );
      });


      /**
       * Archive Channel
       */
      $(".open-archive-channel-modal").click(function(){
      //$(document).once().on('click', '.open-archive-channel-modal', function() {
        var cid = $(this).data('id');
        $(".modal-body #cid").val( cid );
      });

      // Check button.
      if ($('.archive-channel-affirm-button').length > 0) {

        // Attach click
        $('.modal-content').once().on('click', '.archive-channel-affirm-button', function (e) {
          // buttons.on('click', function (e) {
          var cid = document.getElementById('cid');
          cid = cid.value;
          $.ajax({
            type: 'GET',
            contentType: "application/json",
            url: drupalSettings.basepath + 'archiveChannel',
            dataType: 'json',
            success: function (data) {
              // Toastr if successfull.
              Command: toastr["success"]("Channel archived!", "Success")
              toastr.options = {
                "closeButton": false,
                "debug": false,
                "newestOnTop": false,
                "progressBar": false,
                "positionClass": "toast-top-center",
                "preventDuplicates": false,
                "onclick": null,
                "showDuration": "300",
                "hideDuration": "1000",
                "timeOut": "5000",
                "extendedTimeOut": "1000",
                "showEasing": "swing",
                "hideEasing": "linear",
                "showMethod": "fadeIn",
                "hideMethod": "fadeOut"
              }
              location.reload();
            },
            error: function (xhr, ajaxOptions, thrownError) {
              alert('Could not archive channel');
              console.log(xhr.status);
              console.log(thrownError);
            },
            data: {
              _format: 'json',
              cid: cid
            }
          });

        });
      }

      /**
       * Un-archive Channel
       */
      $(".unarchive-channel").click(function(){

        var target_element = $(event.target);
        var cid = $(this).data('id');

        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: 'unarchive-channel',
          dataType: 'json',
          success: function (data) {
            // Toastr if successfull.
            Command: toastr["success"]("Channel unarchived!", "Success")
            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": true,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }

            target_element.parents("tr").hide();
          },
          error: function (xhr, ajaxOptions, thrownError) {
            alert('Could not unarchive channel');
            console.log(xhr.status);
            console.log(thrownError);
          },
          data: {
            _format: 'json',
            cid: cid
          }
        });

      });


      /**
       * Untrash_file
       */
      $(".untrash_file").click(function(){

        var target_element = $(event.target);
        var fid = $(this).data('id');

        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: 'untrash-file',
          dataType: 'json',
          success: function (data) {
            // Toastr if successfull.
            Command: toastr["success"]("File placed back in channel.", "Success")
            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
            target_element.parents("tr").hide();
          },
          error: function (xhr, ajaxOptions, thrownError) {
            alert('Could not untrash file.');
          },
          data: {
            _format: 'json',
            fid: fid
          }
        });

      });



      /**
       * Delete user from usermanager.
       */
      $(document).once().on('click', '.open-delete-user-modal', function() {
        var uid = $(this).data('id');
        $(".modal-body #uid").val( uid );
      });

      // Check button.
      if ($('.delete-user-button').length > 0) {

        // Attach click
        $('.modal-content').once().on('click', '.delete-user-button', function (e) {
          // buttons.on('click', function (e) {
          var uid = document.getElementById('uid');
          uid = uid.value;
          $.ajax({
            type: 'GET',
            contentType: "application/json",
            url: 'users/delete',
            dataType: 'json',
            success: function (data) {
              // Toastr if successfull.
              Command: toastr["success"]("User deleted!", "Success")
              toastr.options = {
                "closeButton": false,
                "debug": false,
                "newestOnTop": false,
                "progressBar": false,
                "positionClass": "toast-top-center",
                "preventDuplicates": false,
                "onclick": null,
                "showDuration": "300",
                "hideDuration": "1000",
                "timeOut": "5000",
                "extendedTimeOut": "1000",
                "showEasing": "swing",
                "hideEasing": "linear",
                "showMethod": "fadeIn",
                "hideMethod": "fadeOut"
              }
              location.reload();
            },
            error: function (xhr, ajaxOptions, thrownError) {
              alert('Could not remove user');
              console.log(xhr.status);
              console.log(thrownError);
            },
            data: {
              _format: 'json',
              uid: uid
            }
          });

        });
      }

      // Wait for the document to load.
      $(document).ready(function () {

        // Get the channel title description wrapper.
        var description = $('.channel-title-description');

        // Check the wrapper.
        if (description.length > 0) {

          var replaceWith = $('<input type="text" class="form-control change-channel-description">');

          // Add the inline edit.
          description.inlineEdit(replaceWith, description);
        }
      });

      $(document).ready(function () {

        // Get the channel title name wrapper.
        var channel_name = $('.channel-name');

        // Check the wrapper.
        if (channel_name.length > 0) {

          var replaceWith = $('<input type="text" class="form-control change-channel-name" maxlength="256">');

           // Add the inline edit.
          channel_name.inlineEditName(replaceWith, channel_name);
        }
      });

      /**
       * The inline edit function.
       *
       * @param replaceWith
       * @param connectWith
       */
      $.fn.inlineEditName = function (replaceWith, connectWith) {

        // Add the hover class for styling.
        $(this).hover(function () {
          $(this).addClass('hover');
        }, function () {
          $(this).removeClass('hover');
        });

        // Attach the click function.
        $(this).click(function () {

          // Get the element.
          var elem = $(this);

          // Hide it.
          elem.hide();

          // Add the replace with.
          replaceWith.val(elem.text());

          elem.after(replaceWith);

          // Set focus for typing.
          replaceWith.focus();

          // Add blur function.
          replaceWith.blur(function () {

            // Make sure there is text.
            if ($(this).val() != "") {

              // Change the value.
              connectWith.val($(this).val()).change();
              elem.text($(this).val());

              // Update the description in the database.
              updateChannelName($(this).val());
            }

            // Remove the textfield again.
            $(this).remove();

            // And show the original.
            elem.show();
          });
        });
      };

      /**
       * Update the description.
       */
      function updateChannelName() {

        var cid = $(".cid").val();
        var channel_name = $('.channel-name').text();
        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: drupalSettings.basepath + 'alterName',
          dataType: 'json',
          success: function (data) {

            $("#title_bar_channel_name").text(channel_name);
            $("#channel_id_left_sidebar_"+cid).text(channel_name);

            toastr["success"]("Changed channel name", "Success");
            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          error: function (xhr, ajaxOptions, thrownError) {
            //alert('Could not add user');
            toastr["error"](thrownError, "Error");
            toastr.options = {
              "closeButton": true,
              "debug": false,
              "newestOnTop": false,
              "progressBar": true,
              "positionClass": "toast-top-center",
              "preventDuplicates": true,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          data: {
            _format: 'json',
            channel_name: channel_name,
            cid: cid
          }
        });

      }

      /**
       * The inline edit function.
       *
       * @param replaceWith
       * @param connectWith
       */
      $.fn.inlineEdit = function (replaceWith, connectWith) {

        // Add the hover class for styling.
        $(this).hover(function () {
          $(this).addClass('hover');
        }, function () {
          $(this).removeClass('hover');
        });

        // Attach the click function.
        $(this).click(function () {

          // Get the element.
          var elem = $(this);

          // Hide it.
          elem.hide();

          // Add the replace with.
          replaceWith.val(elem.text());

          elem.after(replaceWith);

          // Set focus for typing.
          replaceWith.focus();

          // Add blur function.
          replaceWith.blur(function () {

            // Make sure there is text.
            if ($(this).val() != "") {

              // Change the value.
              connectWith.val($(this).val()).change();
              elem.text($(this).val());

              // Update the description in the database.
              updateDescription($(this).val());
            }

            // Remove the textfield again.
            $(this).remove();

            // And show the original.
            elem.show();
          });
        });
      };

      /**
       * Update the description.
       */
      function updateDescription() {

        var cid = $(".cid").val();
        var description = $('.channel-title-description').text();
        $.ajax({
          type: 'GET',
          contentType: "application/json",
          url: drupalSettings.basepath + 'alterdescription',
          dataType: 'json',
          success: function (data) {

            $("#channel_title_description").text(description);

            toastr["success"]("Changed channel description", "Success");

            toastr.options = {
              "closeButton": false,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-center",
              "preventDuplicates": false,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          error: function (xhr, ajaxOptions, thrownError) {
            //alert('Could not add user');
            toastr["error"](thrownError, "Error");

            toastr.options = {
              "closeButton": true,
              "debug": false,
              "newestOnTop": false,
              "progressBar": true,
              "positionClass": "toast-top-center",
              "preventDuplicates": false,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          },
          data: {
            _format: 'json',
            description: description,
            cid: cid
          }
        });

      }


      /**
       * Resize boxes on reload and window resize.
       */

      function resizeChat(){
      var curHeight = $( window ).height();
      var curWidth = $( window ).width();
      var rightSidebarHeight = curHeight-71;
      var chatboxHeight = curHeight-129;
      $("#sidebar-scroll").css("max-height",curHeight+"px");
      $("#chat_messages").css("height",chatboxHeight+"px");
      $("#userlistblockheight").css("max-height",rightSidebarHeight+"px");
      if (curWidth < 1200) {
        $(".userlistblock").hide();
        $(".contentblock").removeClass('padding-fix');
        $(".contentblock").addClass('col-lg-12');
        $(".userlistblock-toggle").removeClass('fa-toggle-right');
        $(".userlistblock-toggle").addClass('fa-toggle-left');
      }
    }

    resizeChat();

    $( window ).resize(function() {
      resizeChat();
    });

     /**
     * User dropdown toggle.
     */

      // Check button.
      if ($('.user-dropdown-toggle').length > 0) {

        // Attach click.
        $('.user-dropdown-toggle').once().on('click', function (e) {

          var test = $(event.target);
          $(".user-dropdown").toggle(200);

        });
      }

     /**
     * Right side channel config toggle.
     */

      // Check button.
      if ($('.userlistblock-toggle').length > 0) {

        // Attach click.
        $('.userlistblock-toggle').once().on('click', function (e) {

          // Check for the original.
          if ($(this).attr('data-original-title') == 'Show Sidebar') {

            // Change the text.
            $(this).attr('data-original-title', 'Hide Sidebar');
          }
          else {
            $(this).attr('data-original-title', 'Show Sidebar');
          }

          if($(".contentblock").hasClass('col-lg-7')) {
            if(!$(".contentblock").is(':visible')){
              $(".contentblock").show();
            }
            $(".userlistblock").hide();
            $(".contentblock").removeClass('col-lg-7');
            $(".contentblock").removeClass('padding-fix');
            $(".contentblock").addClass('col-lg-12');
            $("#collapseOne").removeClass('in');
            $(".userlistblock-toggle").removeClass('fa-toggle-right');
            $(".userlistblock-toggle").addClass('fa-toggle-left');


          } else {
            if($( window ).width() < 1200){
              $(".contentblock").hide();
            }
            $("#collapseOne").addClass('in');
            $(".userlistblock").show();
            $(".contentblock").removeClass('col-lg-12');
            $(".contentblock").addClass('col-lg-7');
            $(".contentblock").addClass('padding-fix');
            $(".userlistblock-toggle").removeClass('fa-toggle-left');
            $(".userlistblock-toggle").addClass('fa-toggle-right');
          }

        });
      }


      // Check button.
      if ($('.userlistblock-toggle-users').length > 0) {

        // Attach click.
        $('.userlistblock-toggle-users').once().on('click', function (e) {

          if($(".contentblock").hasClass('col-lg-7')) {
            if(!$(".contentblock").is(':visible')){
              $(".contentblock").show();
            }
            $(".userlistblock").hide();
            $(".contentblock").removeClass('col-lg-7');
            $(".contentblock").removeClass('padding-fix');
            $(".contentblock").addClass('col-lg-12');
            $("#collapseSix").removeClass('in');
            $(".userlistblock-toggle").removeClass('fa-toggle-right');
            $(".userlistblock-toggle").addClass('fa-toggle-left');

          } else {
            if($( window ).width() < 1200){
              $(".contentblock").hide();
            }
            $("#collapseSix").addClass('in');
            $(".userlistblock").show();
            $(".contentblock").removeClass('col-lg-12');
            $(".contentblock").addClass('col-lg-7');
            $(".contentblock").addClass('padding-fix');
            $(".userlistblock-toggle").removeClass('fa-toggle-left');
            $(".userlistblock-toggle").addClass('fa-toggle-right');
          }

        });
      }

      // Check button.
      if ($('.btn-box-close').length > 0) {
        // Attach click.
        $('.btn-box-close').once().on('click', function (e) {
            if(!$(".contentblock").is(':visible')){
              $(".contentblock").show();
            }
            $(".userlistblock").hide();
            $(".contentblock").removeClass('col-lg-7');
            $(".contentblock").removeClass('padding-fix');
            $(".contentblock").addClass('col-lg-12');
        });
      }





      /**
       * Trash Files.
       */
      var buttons = $('.trash-file');
      // Check button.
      if (buttons.length > 0) {

        $('.product-info').once().on('click', '.trash-file', function (e) {

          var test = $(event.target);
          var fidval = $(".fid");
          var fid = test.find(fidval).val();

          $.ajax({
            type: 'GET',
            contentType: "application/json",
            url: drupalSettings.basepath + 'trash-file',
            dataType: 'json',
            success: function (data) {

              // Hide this file from sidebar
              test.parents("li").hide();

              // Update file count
              var newcount = $(".products-list li:visible").length;
              console.log(newcount);

              // Update user count.
              $("<span id='file-channel-count'> " + newcount + " </span>").replaceAll("#file-channel-count");

              Command: toastr["success"]("File trashed", "Success")

              toastr.options = {
                "closeButton": false,
                "debug": false,
                "newestOnTop": false,
                "progressBar": false,
                "positionClass": "toast-top-center",
                "preventDuplicates": false,
                "onclick": null,
                "showDuration": "300",
                "hideDuration": "1000",
                "timeOut": "5000",
                "extendedTimeOut": "1000",
                "showEasing": "swing",
                "hideEasing": "linear",
                "showMethod": "fadeIn",
                "hideMethod": "fadeOut"
              }


            },
            error: function (xhr, ajaxOptions, thrownError) {
              alert('Could not trash file');
            },
            data: {
              _format: 'json',
              fid: fid
            }
          });

        });
      }




      /**
       * Remove users.
       */
      var buttons = $('.remove-button');
      // Check button.
      if (buttons.length > 0) {

        // Attach click
        $('.users-list').once().on('click', '.remove-button', function (e) {

          var test = $(event.target);

          var uidval = $(".uid");
          var cidval = $(".cid");

          var uid = test.find(uidval).val();
          var cid = test.find(cidval).val();

          $.ajax({
            type: 'GET',
            contentType: "application/json",
            url: drupalSettings.basepath + 'remove',
            dataType: 'json',
            success: function (data) {

              // Hide this user from sidebar
              test.parents("li").hide();
              var newcount = $(".users-list li:visible").length;

              // Update user count.
              $("<span id='user-channel-count'> " + newcount + " </span>").replaceAll("#user-channel-count");

              // Remove user from node.js
                leaveRoom(uid, cid);
              Command: toastr["success"]("User removed!", "Success")

              toastr.options = {
                "closeButton": false,
                "debug": false,
                "newestOnTop": false,
                "progressBar": false,
                "positionClass": "toast-top-center",
                "preventDuplicates": false,
                "onclick": null,
                "showDuration": "300",
                "hideDuration": "1000",
                "timeOut": "5000",
                "extendedTimeOut": "1000",
                "showEasing": "swing",
                "hideEasing": "linear",
                "showMethod": "fadeIn",
                "hideMethod": "fadeOut"
              }


            },
            error: function (xhr, ajaxOptions, thrownError) {
              alert('Could not remove user');
            },
            data: {
              _format: 'json',
              uid: uid,
              cid: cid
            }
          });

        });
      }
      $('#user-add-username').keyup(function (e) {
        if (e.which === 188) {
          console.log(' hallo');
          this.value = this.value.replace(',', '');
        }
      });


      /**
       * Add users.
       */
      $('#user-add-username').once().keypress(function (e) {


        // Check for enter key.
        if (e.which == 13) {

          var formValue = $("#user-add-username").val();
          var cid = $(".cid").val();

          if (formValue != '') {

            $.ajax({
              type: 'GET',
              contentType: "application/json",
              url: drupalSettings.basepath + 'add',
              dataType: 'json',
              success: function (data) {
                $('.users-list').prepend(data.toAppend);
                var newcount = $(".users-list li:visible").length;
                $('<span id="user - channel - count"> ' + newcount + "</span>"
                ).replaceAll("#user-channel-count");
                toastr["success"]("User added!", "Success");

                userAdd(formValue, cid);
                toastr.options = {
                  "closeButton": false,
                  "debug": false,
                  "newestOnTop": false,
                  "progressBar": false,
                  "positionClass": "toast-top-center",
                  "preventDuplicates": false,
                  "onclick": null,
                  "showDuration": "300",
                  "hideDuration": "1000",
                  "timeOut": "5000",
                  "extendedTimeOut": "1000",
                  "showEasing": "swing",
                  "hideEasing": "linear",
                  "showMethod": "fadeIn",
                  "hideMethod": "fadeOut"
                }
              },
              error: function (xhr, ajaxOptions, thrownError) {
                //alert('Could not add user');
                toastr["error"](thrownError, "Error");

                toastr.options = {
                  "closeButton": true,
                  "debug": false,
                  "newestOnTop": false,
                  "progressBar": true,
                  "positionClass": "toast-top-center",
                  "preventDuplicates": false,
                  "onclick": null,
                  "showDuration": "300",
                  "hideDuration": "1000",
                  "timeOut": "5000",
                  "extendedTimeOut": "1000",
                  "showEasing": "swing",
                  "hideEasing": "linear",
                  "showMethod": "fadeIn",
                  "hideMethod": "fadeOut"
                }
              },
              data: {
                _format: 'json',
                name: formValue,
                cid: cid
              }
            });

            // Clear input field.
            $('#user-add-username').val("");
            $('#user-add-username').focus();
          }else{
            toastr["error"]('Empty text not allowed!', "Error");}
        }
      });


      /**
       * Add users via email.
       */
      $('#user-add-email').once().keypress(function (e) {

        // Check for enter key.
        if (e.which == 13) {

          var boxinput = $('#user-add-email').val();
          // Validate email input
          var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
          if (re.test(boxinput)){

            // Fetch channel id from hidden field.
            var cidval = $(".cid");
            var cid = cidval.val();
            var emailaddress = $("#user-add-email").val();

            $.ajax({
              type: 'GET',
              contentType: "application/json",
              url: drupalSettings.basepath + 'add_email',
              dataType: 'json',
              success: function (data) {
                $('.users-list').prepend(data.toAppend);
                var newcount = $(".users-list li:visible").length;
                $("<span id='user-channel-count'> " + newcount + " </span>").replaceAll("#user-channel-count");
                Command: toastr["success"]("User added!", "Success");
                userAdd(boxinput, cid);
                  toastr.options = {
                    "closeButton": false,
                    "debug": false,
                    "newestOnTop": false,
                    "progressBar": false,
                    "positionClass": "toast-top-center",
                    "preventDuplicates": false,
                    "onclick": null,
                    "showDuration": "300",
                    "hideDuration": "1000",
                    "timeOut": "5000",
                    "extendedTimeOut": "1000",
                    "showEasing": "swing",
                    "hideEasing": "linear",
                    "showMethod": "fadeIn",
                    "hideMethod": "fadeOut"
                  }
                },
              error: function (xhr, ajaxOptions, thrownError) {
                Command: toastr["error"](thrownError, "Error")

                toastr.options = {
                  "closeButton": true,
                  "debug": false,
                  "newestOnTop": false,
                  "progressBar": true,
                  "positionClass": "toast-top-center",
                  "preventDuplicates": false,
                  "onclick": null,
                  "showDuration": "300",
                  "hideDuration": "1000",
                  "timeOut": "5000",
                  "extendedTimeOut": "1000",
                  "showEasing": "swing",
                  "hideEasing": "linear",
                  "showMethod": "fadeIn",
                  "hideMethod": "fadeOut"
                }


                // TODO: check the error.
              },
              data: {
                _format: 'json',
                emailaddress: emailaddress,
                cid: cid
              }
            });
            // Clear input field.
            $('#user-add-email').val("");



          } else {
            Command: toastr["error"]("That's not a valid emailaddress!", "Error")

            toastr.options = {
              "closeButton": true,
              "debug": false,
              "newestOnTop": false,
              "progressBar": true,
              "positionClass": "toast-top-center",
              "preventDuplicates": false,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "5000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
          }
        }
      });

      // Scroll to active channel in sidebar.
      var active_task = $('section#sidebar-scroll .sidebar-menu li:not(.channel_li).active');

      if (active_task.length > 0) {
        $('section#sidebar-scroll').animate({
          scrollTop: active_task.offset().top
        }, 500);
      }
    }
  }
}(jQuery, Drupal, drupalSettings));

